//    FastHexaViewer - A fast binary file viewer
//    Copyright (C) 2006  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FastHexaViewer
{
	public partial class GotoForm : Form
	{
		long address = 0;
		bool gotoAsciiSection = false;

		public long Address { get { return this.address; } set { this.address = value; } }
		public bool GotoAsciiSection { get { return this.gotoAsciiSection; } set { this.gotoAsciiSection = value; } }

		public GotoForm()
		{
			InitializeComponent();

			this.textBoxAddress.Text = "0x" + this.address.ToString("X");
			this.checkBoxGotoAsciiSection.Checked = this.gotoAsciiSection;
		}

		private void GotoForm_VisibleChanged(object sender, EventArgs e)
		{
			this.textBoxAddress.Focus();
		}

		private void textBoxAddress_TextChanged(object sender, EventArgs e)
		{
			this.buttonOk.Enabled = (this.textBoxAddress.Text.Length > 0);
		}

		private void GotoForm_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (DialogResult == DialogResult.OK)
			{
				try
				{
					int indexOfHex = this.textBoxAddress.Text.IndexOf("0x", StringComparison.InvariantCultureIgnoreCase);
					if (indexOfHex != -1)
						this.address = long.Parse(this.textBoxAddress.Text.Substring(indexOfHex + 2).Trim(), System.Globalization.NumberStyles.HexNumber);
					else
						this.address = long.Parse(this.textBoxAddress.Text.Trim(), System.Globalization.NumberStyles.Integer);

					this.gotoAsciiSection = this.checkBoxGotoAsciiSection.Checked;
				}
				catch
				{
					MessageBox.Show(this, "Wrong address format!\r\nMust be '0x1234' or '4660'");
					e.Cancel = true;
				}
			}
		}
	}
}