//    FastHexaViewer - A fast binary file viewer
//    Copyright (C) 2006  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FastHexaViewer
{
	public partial class SearchForm : Form
	{
		string searchString = "";
		byte[] searchPattern = new byte[0];
		bool findAscii = false;
		bool matchCase = false;
		bool searchDown = true;

		public string SearchString
		{
			get { return searchString; }
			set { searchString = value; }
		}

		public byte[] SearchPattern
		{
			get { return searchPattern; }
		}

		public bool FindAscii
		{
			get { return findAscii; }
			set { findAscii = value; }
		}

		public bool MatchCase
		{
			get { return matchCase; }
			set { matchCase = value; }
		}

		public bool SearchDown
		{
			get { return searchDown; }
			set { searchDown = value; }
		}

		public SearchForm()
		{
			InitializeComponent();

			this.textBoxSearchString.Text = this.searchString;
			this.checkBoxFindAscii.Checked = this.findAscii;
			this.checkBoxMatchCase.Checked = this.matchCase;
			this.radioButtonUp.Checked = !this.searchDown;
			this.radioButtonDown.Checked = this.searchDown;
		}

		private void SearchForm_VisibleChanged(object sender, EventArgs e)
		{
			this.textBoxSearchString.Focus();
		}

		private void textBoxSearchString_TextChanged(object sender, EventArgs e)
		{
			this.buttonOk.Enabled = (this.textBoxSearchString.Text.Length > 0);
			//if (this.textBoxSearchString.Text.Length > 0 && this.textBoxSearchString.Text.IndexOfAny(new char[] { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'a', 'b', 'c', 'd', 'e', 'f' }) == -1)
			//    this.checkBoxFindAscii.Checked = true;
		}

		private void SearchForm_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (DialogResult == DialogResult.OK)
			{
				this.searchString = this.textBoxSearchString.Text;
				this.findAscii = this.checkBoxFindAscii.Checked;
				this.matchCase = this.checkBoxMatchCase.Checked;
				this.searchDown = this.radioButtonDown.Checked;

				if (!this.findAscii)
				{
					try
					{
						string searchString = this.searchString.Replace(" ", "");
						this.searchPattern = new byte[searchString.Length / 2];
						for (int i = 0; i < searchPattern.Length; i++)
							this.searchPattern[i] = byte.Parse(searchString[i << 1].ToString() + searchString[(i << 1) + 1], System.Globalization.NumberStyles.HexNumber);
					}
					catch
					{
						MessageBox.Show(this, "Wrong pattern format!");
						e.Cancel = true;
					}
				}
			}
		}
	}
}